config/routes.rb
Rails.application.routes.draw do
  resources :articles
  devise_for :users
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
   root "articles#index"
   get 'about', to: 'welcome#about'
   get 'news', to: 'articles#index'
   get 'cooking', to: 'articles#index'
   get 'roastering', to: 'articles#index'
   get 'other', to: 'articles#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/article.rb
class Article < ApplicationRecord
    has_rich_text :body
    has_one_attached :preview_img
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_action :set_article, only: %i[ show edit update destroy ]

  # GET /articles or /articles.json
  def index
    @articles = Article.all
  end

  # GET /articles/1 or /articles/1.json
  def show
  end

  # GET /articles/new
  def new
    @article = Article.new
  end

  # GET /articles/1/edit
  def edit
  end

  # POST /articles or /articles.json
  def create
    @article = Article.new(article_params)

    respond_to do |format|
      if @article.save
        format.html { redirect_to article_url(@article), notice: "Article was successfully created." }
        format.json { render :show, status: :created, location: @article }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @article.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /articles/1 or /articles/1.json
  def update
    respond_to do |format|
      if @article.update(article_params)
        format.html { redirect_to article_url(@article), notice: "Article was successfully updated." }
        format.json { render :show, status: :ok, location: @article }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @article.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /articles/1 or /articles/1.json
  def destroy
    @article.destroy

    respond_to do |format|
      format.html { redirect_to articles_url, notice: "Article was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_article
      @article = Article.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def article_params
      params.require(:article).permit(:title, :body, :preview_img)
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
    def index; end 
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/header_helper.rb
module HeaderHelper
    def current_link_class(path)
        current_page?(path) ? 'nav-link px-2 link-secondary' : 'nav-link px-2 link-dark'
    end
end

app/views/active_storage/blobs/_blob.html.erb
<figure class="attachment attachment--<%= blob.representable? ? "preview" : "file" %> attachment--<%= blob.filename.extension %>">
  <% if blob.representable? %>
    <%= image_tag blob.representation(resize_to_limit: local_assigns[:in_gallery] ? [ 800, 600 ] : [ 1024, 768 ]) %>
  <% end %>

  <figcaption class="attachment__caption">
    <% if caption = blob.try(:caption) %>
      <%= caption %>
    <% else %>
      <span class="attachment__name"><%= blob.filename %></span>
      <span class="attachment__size"><%= number_to_human_size blob.byte_size %></span>
    <% end %>
  </figcaption>
</figure>

app/views/articles/_article.html.erb
<div id="<%= dom_id article %>">
  <h1 class='text-center'><%= article.title %></h1>
  <%= image_tag article.preview_img, class: 'img-fluid rounded mx-auto d-block' if article.preview_img.present? %>
  <p><%= @article.body %></p>
</div>

app/views/articles/_form.html.erb
<%= form_with(model: article) do |form| %>
  <% if article.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(article.errors.count, "error") %> prohibited this article from being saved:</h2>

      <ul>
        <% article.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :title, style: "display: block" %>
    <%= form.text_field :title %>
  </div>
  <div>
    <%= form.file_field :preview_img %>
  </div>
   <div class="field">
    <%= form.label :content %>
    <%= form.rich_text_area :body %>
  </div>
  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/articles/_index_article.html.erb
<div id="<%= dom_id article %>">
  <p>
    <strong>Title:</strong>
    <%= article.title %>
  </p>
</div>

app/views/articles/edit.html.erb
<h1>Editing article</h1>

<%= render "form", article: @article %>

<br>

<div>
  <%= link_to "Show this article", @article %> |
  <%= link_to "Back to articles", articles_path %>
</div>

app/views/articles/index.html.erb
<main><div class="album py-5 bg-light"><div class="container"><div class="row row-cols-1 row-cols-sm-2 row-cols-md-3 g-3">
  <% @articles.each do |article| %>
      <div class='col'>
      <div class="card shadow-sm">
        <%- if article.preview_img.present? %>
          <%= image_tag article.preview_img, class: 'bd-placeholder-img card-img-top', width: '100%', height: '225' %>
        <% else %>
        <svg class="bd-placeholder-img card-img-top" width="100%" height="225" xmlns="http://www.w3.org/2000/svg" role="img" aria-label="Placeholder: Thumbnail" preserveAspectRatio="xMidYMid slice" focusable="false"><title>Placeholder</title><rect width="100%" height="100%" fill="#55595c"></rect></svg>
         <% end %> 
          <div class="card-body">
            <p class="card-text"><%= render 'index_article', article: article %></p>
            <div class="d-flex justify-content-between align-items-center">
              <div class="btn-group">
                <%= link_to "Show this article", article, type: 'button', class: 'btn btn-sm btn-outline-secondary' %>
                <%= link_to "Edit", edit_article_path(article), type: 'button', class: 'btn btn-sm btn-outline-secondary' %>
              </div>
            <small class="text-muted">9 mins</small>
            </div>
          </div>
      </div>
      </div>
  <% end %>
</div></div></div></main>

app/views/articles/new.html.erb
<h1>New article</h1>
<%= render "form", article: @article %>
<br>
<div>
  <%= link_to "Back to articles", articles_path %>
</div>

app/views/articles/show.html.erb
<%= render @article %>

<div>
  <%= link_to "Edit this article", edit_article_path(@article) %> |
  <%= link_to "Back to articles", articles_path %>
  <%= button_to "Destroy this article", @article, method: :delete %>
</div>

app/views/layouts/_flash_message.html.erb
<p class='notice' style='color: green;'><%= notice %></p>
<p class='alert' style='color: yellow'><%= alert %></p>

app/views/layouts/_footer.html.erb
<footer class="text-muted py-5">
  <div class="container">
    <p class="float-end mb-1">
      <a href="#">Back to top</a>
    </p>
    <p class="mb-1">© <%= Date.today.year %> KavaFans. All rights reserved.</p>
  </div>
</footer>

app/views/layouts/_header.html.erb
<header class='d-flex flex-wrap align-item-center justifu-content-center justify-content-md-between py-3 mb-4 border-bottom'>
    <%= link_to root_path do %>
      <%= image_tag('logo.png', width: '140px') %>
    <% end %>
    
    <ul class='nav col-12 col-lg-auto me-lg-auto mb-2 justify-content-center mb-md-0'>
      <li><%= link_to t('header.menu.news'), news_path, class: current_link_class(news_path) %></li>
      <li><%= link_to t('header.menu.cooking'), cooking_path, class: current_link_class(cooking_path) %></li>
      <li><%= link_to t('header.menu.roastering'), roastering_path, class: current_link_class(roastering_path) %></li>
      <li><%= link_to t('header.menu.other'), other_path, class: current_link_class(other_path) %></li>
      <li><%= link_to t('header.menu.about'), about_path, class: current_link_class(about_path) %></li>
    </ul>
    
    <%- if user_signed_in? %>
      <div class="dropdown text-end">
        <a href="#" class="d-block link-dark text-decoration-none dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">
          <img src="https://github.com/mdo.png" alt="mdo" width="32" height="32" class="rounded-circle">
        </a>
         <ul class="dropdown-menu text-small" style="">
          <li><%= link_to t('articles.buttons.new'), new_article_path, class: 'dropdown-item' %></li>
          <li><%= link_to t('devise.account'), edit_user_registration_path, class: 'dropdown-item' %></li>
          <li><hr class="dropdown-divider"></li>
          <li><%= button_to t('devise.logout'), destroy_user_session_path, method: :delete, form: {turbolink: false}, class: 'dropdown-item' %></li>
        </ul>
      </div>
    <% else %>
    <div class='text-end'>
      <%= link_to new_user_session_path do %><button type='button' class='btn btn-primary me-2'><%= t('devise.sessions.new.sign_in') %></button><% end %>
      <%= link_to new_user_registration_path do %><button type='button' class='btn btn-warning'><%= t('devise.registrations.new.sign_up') %></button><% end %>
    </div>
    <% end %>
</header>

app/views/layouts/action_text/contents/_content.html.erb
<div class="trix-content">
  <%= yield -%>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>KavaFans</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
    <%# javascript_include_tag "application", defer: true %>
  </head>

  <body>
  <div class="container">
    <%= render 'layouts/header' %>
    <%= render 'layouts/flash_message' %>
    <%= yield %>
    <%= render 'layouts/footer' %>
  </div>
  </body>
</html>

app/views/welcome/about.html.erb
<section class="py-5 text-center container">
  <div class="row py-lg-5"><div class="col-lg-6 col-md-8 mx-auto">
      <h1 class="fw-light"><%= t('welcome.title') %></h1><p class="lead text-muted"><%= t('welcome.description') %></p>
    </div>
  </div>
</section>

app/views/welcome/index.html.erb
<body>
  <main>
    
    <div class="album py-5 bg-light">
      <div class="container">
        <div class="row row-cols-1 row-cols-sm-2 row-cols-md-3 g-3">
          <div class="col">
            <div class="card shadow-sm">
              <svg class="bd-placeholder-img card-img-top" width="100%" height="225" xmlns="http://www.w3.org/2000/svg" role="img" aria-label="Placeholder: Thumbnail" preserveAspectRatio="xMidYMid slice" focusable="false"><title>Placeholder</title><rect width="100%" height="100%" fill="#55595c"/><text x="50%" y="50%" fill="#eceeef" dy=".3em">Thumbnail</text></svg>
              <div class="card-body">
                <p class="card-text">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
                <div class="d-flex justify-content-between align-items-center">
                  <div class="btn-group">
                    <button type="button" class="btn btn-sm btn-outline-secondary">View</button>
                    <button type="button" class="btn btn-sm btn-outline-secondary">Edit</button>
                  </div>
                  <small class="text-muted">9 mins</small>
                </div>
              </div>
            </div>
          </div>
          <div class="col">
            <div class="card shadow-sm">
              <svg class="bd-placeholder-img card-img-top" width="100%" height="225" xmlns="http://www.w3.org/2000/svg" role="img" aria-label="Placeholder: Thumbnail" preserveAspectRatio="xMidYMid slice" focusable="false"><title>Placeholder</title><rect width="100%" height="100%" fill="#55595c"/><text x="50%" y="50%" fill="#eceeef" dy=".3em">Thumbnail</text></svg>
              <div class="card-body">
                <p class="card-text">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
                <div class="d-flex justify-content-between align-items-center">
                  <div class="btn-group">
                    <button type="button" class="btn btn-sm btn-outline-secondary">View</button>
                    <button type="button" class="btn btn-sm btn-outline-secondary">Edit</button>
                  </div>
                  <small class="text-muted">9 mins</small>
                </div>
              </div>
            </div>
          </div>
          <div class="col">
            <div class="card shadow-sm">
              <svg class="bd-placeholder-img card-img-top" width="100%" height="225" xmlns="http://www.w3.org/2000/svg" role="img" aria-label="Placeholder: Thumbnail" preserveAspectRatio="xMidYMid slice" focusable="false"><title>Placeholder</title><rect width="100%" height="100%" fill="#55595c"/><text x="50%" y="50%" fill="#eceeef" dy=".3em">Thumbnail</text></svg>
              <div class="card-body">
                <p class="card-text">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
                <div class="d-flex justify-content-between align-items-center">
                  <div class="btn-group">
                    <button type="button" class="btn btn-sm btn-outline-secondary">View</button>
                    <button type="button" class="btn btn-sm btn-outline-secondary">Edit</button>
                  </div>
                  <small class="text-muted">9 mins</small>
                </div>
              </div>
            </div>
          </div>
      </div>
  </main>
<!--    <script src="../assets/dist/js/bootstrap.bundle.min.js"></script> -->
</body>